'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rule = require('rockey/rule');

var _rule2 = _interopRequireDefault(_rule);

var _when = require('rockey/when');

var _when2 = _interopRequireDefault(_when);

var _insert = require('rockey/insert');

var _insert2 = _interopRequireDefault(_insert);

var _condition = require('rockey/condition');

var _condition2 = _interopRequireDefault(_condition);

var _htmlTags = require('./htmlTags');

var _htmlTags2 = _interopRequireDefault(_htmlTags);

var _ = require('./');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var createRockeyHoc = function createRockeyHoc(BaseComponent, displayName, css) {
  if (BaseComponent.extends) {
    return BaseComponent.extends(displayName, css);
  } else {
    return (0, _2.default)(displayName, BaseComponent, css);
  }
};

var look = function look(BaseComponent) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$extendBase = _ref.extendBase,
      extendBase = _ref$extendBase === undefined ? true : _ref$extendBase;

  return function () {
    var css = _rule2.default.apply(undefined, arguments);

    return css.transform(function (tree, create) {
      var components = Object.keys(tree.components);
      var size = components.length;

      if (!size) {
        throw new Error('Rockey look should containt at least one root component');
      }

      var parentDisplayName = components[0];
      var baseCss = create({
        components: _defineProperty({}, parentDisplayName, tree.components[parentDisplayName])
      });

      var children = {};

      for (var i = 1; i < size; i++) {
        var displayName = components[i];

        var comopnentCss = create({
          components: _defineProperty({}, displayName, tree.components[displayName])
        });

        if (extendBase) {
          comopnentCss.addParent(baseCss);
        }

        var ChildRockeyHoc = createRockeyHoc(BaseComponent, displayName, comopnentCss);

        children[displayName] = ChildRockeyHoc;
        BaseComponent[displayName] = ChildRockeyHoc;
      }

      var ParentRockeyHoc = createRockeyHoc(BaseComponent, parentDisplayName, baseCss);

      BaseComponent[parentDisplayName] = ParentRockeyHoc;

      return Object.assign({}, children, _defineProperty({}, parentDisplayName, ParentRockeyHoc));
    });
  };
};

look.when = _when2.default;
look.condition = _condition2.default;
look.insert = _insert2.default;

var _loop = function _loop(tag) {
  // ---- tag hoc lazy creation
  Object.defineProperty(look, tag, {
    get: function get() {
      return function () {
        var TagComponent = function TagComponent(props) {
          return _react2.default.createElement(tag, props);
        };

        return look(TagComponent).apply(undefined, arguments);
      };
    }
  });
};

var _iteratorNormalCompletion = true;
var _didIteratorError = false;
var _iteratorError = undefined;

try {
  for (var _iterator = _htmlTags2.default[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
    var tag = _step.value;

    _loop(tag);
  }
} catch (err) {
  _didIteratorError = true;
  _iteratorError = err;
} finally {
  try {
    if (!_iteratorNormalCompletion && _iterator.return) {
      _iterator.return();
    }
  } finally {
    if (_didIteratorError) {
      throw _iteratorError;
    }
  }
}

exports.default = look;